/*****************************************************************/
/*      protocol.h                                               */
/*      Henri Casanova, Dorian Arnold                            */
/*****************************************************************/

#ifndef __NS_PROTOCOL_H
#define __NS_PROTOCOL_H


/**
 **  MACRO DEFINITIONS
 **/

#define NS_PROT_WORKLOAD_REPORT 	777
#define NS_PROT_SV_REGISTER	      	778
#define NS_PROT_REGISTRATION_REFUSED   	779
#define NS_PROT_REGISTRATION_ACCEPTED	780
#define NS_PROT_AG_REGISTER	      	781
#define NS_PROT_NEW_AGENT	      	782
#define NS_PROT_PROBLEM_INFO	      	783
#define NS_PROT_PROBLEM_NOT_FOUND      	784
#define NS_PROT_PROBLEM_DESC      	785
#define NS_PROT_NETWORK_REPORT		786
#define NS_PROT_PONG_LATENCY		787
#define NS_PROT_PONG_BANDWIDTH		788
#define NS_PROT_PROBLEM_SOLVE		789
#define NS_PROT_INTERNAL_FAILURE	790
#define NS_PROT_SV_FAILURE		791
#define NS_PROT_PROBLEM_SUBMIT		792
#define NS_PROT_BAD_SPECIFICATION	793
#define NS_PROT_OK			794
#define NS_PROT_ACCEPTED		795
#define NS_PROT_NOT_ALLOWED		796
#define NS_PROT_REGISTER_AGAIN		797
#define NS_PROT_PROTOCOL_ERROR		798
#define NS_PROT_SERVICE_FINISHED	799
#define NS_PROT_UPF_ERROR		800
#define NS_PROT_UPF_UNSAFE		801
#define NS_PROT_SOLVED			802
#define NS_PROT_BAD_VALUES		803
#define NS_PROT_DIM_MISMATCH		804
#define NS_PROT_NO_SOLUTION		805
#define NS_PROT_SERVER_LIST		806
#define NS_PROT_AGENT_LIST		807
#define NS_PROT_PROBLEM_LIST		808
#define NS_PROT_JOB_COMPLETED		809
#define NS_PROT_KILLED			810
#define NS_PROT_SERVER_PORT		811
#define NS_PROT_KILL_AGENT		812
#define NS_PROT_KILL_SERVER		813
#define NS_PROT_SERVICE_PID		814
#define NS_PROT_ARE_YOU_THERE		815
#define NS_PROT_I_AM_THERE		816
#define NS_PROT_NB_SERVERS		817
#define NS_PROT_KILL_JOB		818
#define NS_PROT_SEND_REQUEST		819
#define NS_PROT_WAIT_JOB		820
#define NS_PROT_SV_INFO			821
#define NS_PROT_SV_NOT_FOUND		822
#define NS_PROT_PONG_REQUEST		823
#define NS_PROT_RM_JOB_DESC		824
#define NS_PROT_SEND_ASSIGNMENT		825
#define NS_PROT_PROBE_REQUEST		826
#define NS_PROT_SV_DESC			827
#define NS_PROT_JOB_REPORT		828
#define NS_PROT_LIFE_LINK		829
#define NS_PROT_DIE			830
#define NS_PROT_JUST_CHECKING		831
#define NS_PROT_SEND_SEQUENCE_REQUEST   832
#define NS_PROT_PROBLEM_SOLVE_SEQUENCE	833
#define NS_PROT_NO_SERVER	834
#define NS_PROT_NEW_JOB_DESC		835
#define NS_PROT_KRB5_AUTH_REQUIRED  836
#define NS_PROT_AUTH_FAILED     837
#define NS_PROT_PROBLEM_INPUT 838
#define NS_PROT_NEW_CLIENT_PID 839    /* win32 specific */
#define NS_PROT_AWAIT_COMPLETION 840
#define NS_PROT_STORE_HANDLE 841
#define NS_PROT_GET_HANDLE 842
#define NS_PROT_HANDLE_NOT_FOUND 843
#define NS_PROT_HANDLE 844

/*
 * Error reports from a client
 */
#define HOST_ERROR   0	/* The host failed 	*/
#define SERVER_ERROR 1	/* The server failed 	*/

#endif

